/*
 * Sardan Alexandru-Cezar
 * Stanciu Alexandru-Marian
 * 332CA
 */
 
#include <avr/io.h>
#define F_CPU 16000000
#include <avr/interrupt.h>
#include <util/delay.h>

#define INAINTE 0xAA
#define DREAPTA 0x22
#define STANGA 0x88
#define ITRIG 0x44
#define TRIG 0x11
#define MOTOR_DR OCR1AL
#define MOTOR_ST OCR1BL

void move (unsigned char dir);

unsigned char i, rdev, ldev, ip, delay, dir, power, history;

void init()
{
/* Senzorii, input */
PORTA = 0x00;
DDRA = 0x00;

/* Input pentru driver */
PORTC = 0x00;
DDRC = 0xFF;

/* Enable A/B */
PORTD = 0x0;
PORTD = (1<<PD0) | (1<<PD1);
DDRD = (1<<PD0) | (1<<PD1);

/* Initializare timer1
   Fast PWM pe 8 biti
   clk/8
*/
TCCR1A = (1 << WGM10) | (1 << COM1A1) | (1 << COM1B1);
TCCR1B = (1 << WGM12) | (1 << CS11);
OCR1AL = 0xFF;
OCR1BL = 0xFF;
}

int main(void)
{
	unsigned char sensor;
	while (1)
	{
		_delay_ms(10);
		sensor = PINA;
		if(PINA != 255)
		{
			ldev = rdev = 0;
			if(!bit_is_set(sensor, 3))
				rdev = 1;
			if(!bit_is_set(sensor, 2))
				rdev = 2;
			if(!bit_is_set(sensor, 1))
				rdev = 3;
			if(!bit_is_set(sensor, 0))
				rdev = 4;
			if(!bit_is_set(sensor, 4))
				ldev = 1;
			if(!bit_is_set(sensor, 5))
				ldev = 2;
			if(!bit_is_set(sensor, 6))
				ldev = 3;
			if(!bit_is_set(sensor, 7))
				ldev = 4;
			if(rdev > ldev)
				move(DREAPTA);
			if(rdev < ldev)
				move(STANGA);
			if(rdev==ldev)
				move(INAINTE);
		}
		else 
		{
			if(history == STANGA)
				move(ITRIG);
			else
				move(TRIG);
		}
	}
	return 0;
}

void move (unsigned char dir) 
{
	PORTC=dir;
	if(dir==STANGA || dir==DREAPTA) 
		history = dir;
		
	MOTOR_ST = 255;
	MOTOR_DR = 255;
	if((dir == TRIG) || (dir == ITRIG))
		_delay_ms(100);
}